﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Cv1
{
    public class MyStackEnumerator<TData> : IEnumerator<TData>
    {

        private TData[] Data;
        private int Top;

        private int pointer;

        public MyStackEnumerator(TData[] data, int top) {
            this.Data = data;
            this.Top = top;
            this.pointer = top;
        }


        public TData Current
        {
            get
            {
                return this.Data[this.pointer];
            }
        }

        object IEnumerator.Current
        {
            get
            {
                return this.Data[this.pointer];
            }
        }

        public void Dispose()
        {
        }

        public bool MoveNext()
        {
            if (pointer == 0) { return false; }
            pointer--;
            return true;
        }

        public void Reset()
        {
            this.pointer = this.Top;
        }
    }
}
